#include "app.h"

/****************************************************************************
 *	
 ****************************************************************************/

//#define STAR_MAX	1024
//P/ECE͉ʂĐƌÂ炢̂ŁA炵܂B
#define STAR_MAX	256

typedef struct _STAR {
	fixed px;
	fixed py;
	fixed vel;
	int color;
} STAR;

static STAR star_tbl[STAR_MAX];

static void TSKbgStarDraw(TSK* tsk);

void
TSKbgStar(TSK* tsk)
{
	int i;
	STAR* star;

	switch(tsk->step) {
	case 0:
		tsk->fp_draw = TSKbgStarDraw;
		for(i = 0; i < STAR_MAX; i++) {
			star = &star_tbl[i];
			star->px = FRND_RANGE(seed, fld(-SCREEN_MX), fld(SCREEN_MX));
			star->py = FRND_RANGE(seed, fld(-SCREEN_MY), fld(SCREEN_MY));
			star->vel = FRND_RANGE(seed, fld(0.5), fld(1.5));
			star->color = RND32_RANGE(seed, 0, 3);
		}
		tsk->step++;
		break;

	case 1:
		for(i = 0; i < STAR_MAX; i++) {
			star = &star_tbl[i];
			fsub_(star->py, fadd(star->vel, scr_vel));
			if(ficom(star->py, <, -SCREEN_MY)) fiadd_(star->py, SCREEN_SY);
			if(ficom(star->py, >=, SCREEN_MY)) fisub_(star->py, SCREEN_SY);
		}
		break;

	default:
		clrTSK(tsk);
		break;
	}
}

static void
TSKbgStarDraw(TSK* tsk)
{
	int i;
	STAR* star;
	int x;
	int y;

	for(i = 0; i < STAR_MAX; i++) {
		star = &star_tbl[i];
		x = getPointX(star->px);
		y = getPointY(star->py);
		render_point(&render, x, y, star->color);
	}
}

