#include "app.h"

/****************************************************************************
 *	
 ****************************************************************************/

static void collision();
static void collision_sub1(TSK* tsk, int group);
static void collision_sub2(TSK* tsk, int group);

void
boot()
{
	/* OtBbN */
	INITenemy();

	/* TEh */
	sndINIT();

	/* BulletML */
	bulletINIT();

	/* ^XN */
	initTSK();

	/* O[oRg[^XNN */
	setTSK(GROUP_SYSTEM, TSKgctrl);

	/* C[v */
	for(;;) {
		schedule();
		surface_clear(&surface, 3);

		/* ^XNs */
		execTSK();

		/* 蔻 */
		collision();

		/* ^XN` */
		drawTSK();
	}
}

static void
collision()
{
	LIST_ENTRY* head;
	LIST_ENTRY* link;
	TSK* tsk;

	if(ship_tsk && ship_tsk->fp_int) {
		collision_sub1(ship_tsk, GROUP_ESHOT);
	}

	head = &TskIndex[GROUP_ENEMY];
	link = head->Flink;
	while(head != link) {
		tsk = (TSK*)link;
		link = link->Flink;
		if(tsk->fp_int) {
			collision_sub2(tsk, GROUP_SSHOT);
		}
	}
}

static void
collision_sub1(TSK* tsk, int group)
{
	LIST_ENTRY* head;
	LIST_ENTRY* link;
	TSK* etsk;

	int ssx = tsk->px - tsk->cx;
	int ssy = tsk->py - tsk->cy;
	int sex = tsk->px + tsk->cx;
	int sey = tsk->py + tsk->cy;

	head = &TskIndex[group];
	link = head->Flink;
	while(head != link) {
		etsk = (TSK*)link;
		link = link->Flink;
		if(etsk->fp_int) {
			if((etsk->px - etsk->cx)/*dsx*/ >= sex) continue;
			if((etsk->px + etsk->cx)/*dex*/ <= ssx) continue;
			if((etsk->py - etsk->cy)/*dsy*/ >= sey) continue;
			if((etsk->py + etsk->cy)/*dey*/ <= ssy) continue;
			tsk->fp_int(tsk, etsk);
			return;
		}
	}
}

static void
collision_sub2(TSK* tsk, int group)
{
	LIST_ENTRY* head;
	LIST_ENTRY* link;
	TSK* etsk;

	float ssx = tsk->px - tsk->cx;
	float ssy = tsk->py - tsk->cy;
	float sex = tsk->px + tsk->cx;
	float sey = tsk->py + tsk->cy;

	head = &TskIndex[group];
	link = head->Flink;
	while(head != link) {
		etsk = (TSK*)link;
		link = link->Flink;
		if(etsk->fp_int) {
			if((etsk->px - etsk->cx)/*dsx*/ >= sex) continue;
			if((etsk->px + etsk->cx)/*dex*/ <= ssx) continue;
			if((etsk->py - etsk->cy)/*dsy*/ >= sey) continue;
			if((etsk->py + etsk->cy)/*dey*/ <= ssy) continue;
			etsk->fp_int(etsk, tsk);
			tsk->fp_int(tsk, etsk);
			return;
		}
	}
}

