#include "app.h"

/****************************************************************************
 *	
 ****************************************************************************/

void
INITenemy()
{
	int i;
	int j;
	float r;
	float d;

	for(i = 0; i < ENEMY_DIV1; i++) {
		r = 24 - i * 3; /* 24,21,18,15 */
		for(j = 0; j < ENEMY_DIV2; j++) {
			d = M_PI2 * j / ENEMY_DIV2;
			enemy_poly[i * ENEMY_DIV2 + j][0] = sin(d) * r;
			enemy_poly[i * ENEMY_DIV2 + j][1] = cos(d) * r;
		}
	}
}

void
TSKenemyInt(TSK* tsk, TSK* etsk)
{
	int i;
	int j;

	tsk->fp_int = NULL;
	if(--tsk->energy) {
		playSND(SND_SEEDMG);
		bulletSet(tsk, BULLET_ENEMY01);
		effSetParticle(etsk, 8);
	} else {
		for(i = 0; i < 4/**/; i++) {
			for(j = 0; j < ENEMY_DIV1; j++) {
				effSetBrokenLine(tsk, enemy_poly + j * ENEMY_DIV2, ENEMY_DIV2, 1.0f);
			}
		}
		tsk->fp_draw = NULL;
		playSND(SND_SEEBRK1 + (rand() % 3));
		bulletSet(tsk, BULLET_ENEMY02);
		score += tsk->score;
		tsk->step = 100;
	}
	tsk->rank += 0.1f;
}

void
TSKenemyDraw(TSK* tsk)
{
	int x = _getPointX(-tsk->px);
	int y = _getPointY(-tsk->py);
	int sprno = SPR_ENEMY0 + (tsk->cnt / 8 & 3);
	int param = tsk->fp_int ? DRW_NOMAL : DRW_MASK(2);
	sprite_draw(x, y, sprno, param);
}

/****************************************************************************
 *	
 ****************************************************************************/

static void TSKeshotInt(TSK* tsk, TSK* etsk);
static void TSKeshotDraw(TSK* tsk);

void
TSKeshot(TSK* tsk)
{
	switch(tsk->step) {
	case 0:
		tsk->fp_int = TSKeshotInt;
		tsk->fp_draw = TSKeshotDraw;
		tsk->cx = 4.0f;
		tsk->cy = 4.0f;
		tsk->step++;
		break;

	case 1:
		bulletRun(tsk);
		tsk->px -= sin(tsk->bullet_dir) * tsk->bullet_spd;
		tsk->py -= cos(tsk->bullet_dir) * tsk->bullet_spd;
		tsk->px -= tsk->bullet_accx;
		tsk->py -= tsk->bullet_accy;
		if((tsk->px < -ENEMY_AREAMAX_X) ||
		   (tsk->px > +ENEMY_AREAMAX_X) ||
		   (tsk->py < -ENEMY_AREAMAX_Y) ||
		   (tsk->py > +ENEMY_AREAMAX_Y)) {
			tsk->step = -1;
		}
		break;

	default:
		clrTSK(tsk);
		break;
	}
}

static void
TSKeshotInt(TSK* tsk, TSK* etsk)
{
	tsk->step = -1;
}

static void
TSKeshotDraw(TSK* tsk)
{
	int x = _getPointX(-tsk->px);
	int y = _getPointY(-tsk->py);
	sprite_draw(x, y, SPR_ESHOT, DRW_NOMAL);
}

