#include "app.h"

/****************************************************************************
 *	
 ****************************************************************************/

static void TSKenemyAnim1(TSK* tsk);
static void TSKenemyAnim2(TSK* tsk);

#define SCORE	5
#define ENERGY	5

void
TSKenemy02(TSK* tsk)
{
	switch(tsk->step) {
	case 0:
		tsk->fp_draw = TSKenemyDraw;
		tsk->px = (rand() % (SCREEN_SX - 64)) - (SCREEN_MX - 32);	/* -(SCREEN_MX-32) ` +(SCREEN_MX-32) */
		tsk->py = -SCREEN_MY - 24.0f;
		tsk->ty = -64.0f + ((rand() % 32) - 16.0f);	/* -64-16 ` -64+16 */
		tsk->cx = 16.0f;
		tsk->cy = 8.0f;
		tsk->energy = ENERGY;
		tsk->score = SCORE;
		tsk->wait = 60;
		tsk->step++;
		break;

	case 1:
		tsk->fp_int = TSKenemyInt;
		TSKenemyAnim1(tsk);
		bulletRun(tsk);
		if(--tsk->wait <= 0) {
			tsk->cen_x = tsk->px;
			tsk->cen_y = tsk->py - 32.0f;
			tsk->rad_x = 48.0f;
			tsk->rad_y = 32.0f;
			tsk->ang = M_PI2;
			tsk->step++;
		}
		break;

	case 2:
		tsk->fp_int = TSKenemyInt;
		TSKenemyAnim2(tsk);
		bulletRun(tsk);
		break;

	case 100:
		if(!bulletRun(tsk)) {
			tsk->step = -1;
		}
		break;

	default:
		enemy_now--;
		enemy_dst++;
		if(!(enemy_dst % 20)) enemy_max++;
		clrTSK(tsk);
		break;
	}
}

static void
TSKenemyAnim1(TSK* tsk)
{
	tsk->cnt = (tsk->cnt + 1) & 63;
	tsk->py += (tsk->ty - tsk->py) / 15.0f;
}

static void
TSKenemyAnim2(TSK* tsk)
{
	tsk->cnt = (tsk->cnt + 1) & 63;
	tsk->px = tsk->cen_x + sin(tsk->ang) * tsk->rad_x;
	tsk->py = tsk->cen_y + cos(tsk->ang) * tsk->rad_y;
	if((tsk->ang += M_PI / 15.0f) >= M_PI) tsk->ang -= M_PI2;
}

