#include "app.h"

/****************************************************************************
 *	
 ****************************************************************************/

static void TSKclrAll();
static void gctrl_playinit();
static int gctrl_play();
static int record_highscore();
static void TSKgctrlDrawStart(TSK* tsk);

void
TSKgctrl(TSK* tsk)
{
	int ret;

	switch(tsk->step) {
	case GCTRL_INIT:
		/* IWiłł̓nCXRȀsXebvłA
		 * P/ECEłł͖Iȏsvł邽߁A܂B
		 */
		tsk->step = GCTRL_TITLE;
		break;

	case GCTRL_TITLE:
		setTSK(GROUP_BG, TSKbgStar);			/* ^Cgwi̐^XNJn */
		scr_vel = fld(1.0);
		setTSK(GROUP_INFO, TSKtitle);			/* ^Cgj[I^XNJn */
		playSND(SND_BGM00);				/* ^CgBGMJn */
		g_step = GSTEP_TITLE;
		tsk->step = GCTRL_WAIT;
		break;

	case GCTRL_WAIT:
		if(g_step == GSTEP_TITLE) {			/* ^Cgj[IȂΌp */
			break;
		}
		TSKclrAll();					/* ^XNNA */
		stopSND(0);					/* ^CgBGM~ */
		if(g_step == GSTEP_GAME) {			/* Q[JnȂ... */
			playSND(SND_SESTART);			/* Q[JnSE炷 */
			tsk->fp_draw = TSKgctrlDrawStart;	/* START_ŕ\Jn */
			tsk->wait = 128;
		} else {					/* ȊOȂ΂ɑJڂ */
			tsk->wait = 0;
		}
		tsk->step = GCTRL_START;
		/*FALLTHRU*/

	case GCTRL_START:
		if(--tsk->wait > 0) {				/* START_ŕ\ȂΌp */
			break;
		}
		tsk->fp_draw = NULL;				/* START_ŕ\I */
		if(g_step == GSTEP_GAME) {			/* Q[JnȂ... */
			gctrl_playinit();			/* Q[ */
			playSND(SND_BGM01);			/* Q[BGMJn */
			tsk->wait = 60;				/* ŏ̓Go܂ł̎ */
			tsk->step = GCTRL_GAME2;
			break;
		}
		if(g_step == GSTEP_RANKING) {			/* LOȂ... */
			ranking_exec = -1;			/* nCCg̃LOs}[N */
			tsk->step = GCTRL_RANKING;
			break;
		}
		break;

	case GCTRL_GAME1:
		if(enemy_now < enemy_max) {			/* Go */
			if(enemy_dst < 10) {
				setTSK(GROUP_ENEMY, TSKenemy01);
			} else if(enemy_dst < 20) {
				setTSK(GROUP_ENEMY, TSKenemy02);
			} else {
				if(!(enemy_cnt & 1)) {
					setTSK(GROUP_ENEMY, TSKenemy01);
				} else {
					setTSK(GROUP_ENEMY, TSKenemy02);
				}
			}
			enemy_cnt++;
			enemy_now++;
			tsk->wait = 15;
			tsk->step = GCTRL_GAME2;
		}
		ret = gctrl_play();
		if(ret == 1) tsk->step = GCTRL_GAME3;		/* Q[I[o[ */
		if(ret == 2) tsk->step = GCTRL_GAMEEND;		/* f */
		break;

	case GCTRL_GAME2:
		if(--tsk->wait <= 0) {
			tsk->step = GCTRL_GAME1;
		}
		ret = gctrl_play();
		if(ret == 1) tsk->step = GCTRL_GAME3;		/* Q[I[o[ */
		if(ret == 2) tsk->step = GCTRL_GAMEEND;		/* f */
		break;

	case GCTRL_GAME3:
		stopSND(0);					/* Q[BGM~ */
		tsk->step = GCTRL_GAME4;
		/*FALLTHRU*/

	case GCTRL_GAME4:
		if(!(joy & TRG_A)) {				/* {^܂ŃUg\p */
			break;
		}
		ret = record_highscore();			/* NC? */
		if(ret != RANKING_MAX) {
			ranking_exec = ret + 1;			/* nCCgL̃LOs}[N */
			tsk->step = GCTRL_RANKING;
			break;
		}
		tsk->step = GCTRL_GAMEEND;
		/*FALLTHRU*/

	case GCTRL_GAMEEND:
		TSKclrAll();					/* ^XNNA */
		stopSND(0);					/* Q[BGM~ */
		tsk->step = GCTRL_TITLE;
		break;

	case GCTRL_RANKING:
		TSKclrAll();					/* ^XNNA */
		setTSK(GROUP_BG, TSKbgStar);			/* LOwi̐^XNJn */
		scr_vel = FRND_RANGE(seed, fld(1.0), fld(9.0));
		setTSK(GROUP_INFO, TSKranking);			/* LO^XNJn */
		playSND(SND_BGM02);				/* LOBGMJn */
		tsk->step = GCTRL_RANKING_EXEC;
		/*FALLTHRU*/

	case GCTRL_RANKING_EXEC:
		if(ranking_exec) {				/* LOsȂΌp */
			break;
		}
		TSKclrAll();					/* ^XNNA */
		stopSND(0);					/* LOBGM~ */
		tsk->step = GCTRL_RANKING_EXIT;
		/*FALLTHRU*/

	case GCTRL_RANKING_EXIT:
		/* IWiłłBGM̃tF[hAEg҂sXebvłA
		 * P/ECEłłBGM̃tF[hAEgsȂ̂ŁA܂B
		 */
		tsk->step = GCTRL_TITLE;
		break;

	default:
		exit(0);
	}
}

/* SẴ^XNI܂B
 * ATSKgctrlgGROUP_00͏O܂B
 */
static void
TSKclrAll()
{
	int i;
	for(i = GROUP_01; i <= GROUP_08; i++) {
		clrTSKgroup(i);
	}
}

static void
gctrl_playinit()
{
	setTSK(GROUP_BG, TSKbgStar);
	scr_vel = fld(1.0);
	setTSK(GROUP_SHIP, TSKship);
	setTSK(GROUP_INFO, TSKsysinfo);
	score = 0;
	brk_ship = 0;
	enemy_max = 4;
	enemy_now = 0;
	enemy_dst = 0;
	enemy_cnt = 0;
	play_time = ONE_MIN;
}

static int
gctrl_play()
{
	play_time--;
	if(!play_time) {
		clrTSKgroup(GROUP_SSHOT);
		g_step = GSTEP_RESULT;
		return 1;
	}
	if(g_step == GSTEP_GAME) {
		if(joy & TRG_B) {
			return 2;
		}
	}
	fadd_(scr_vel, fld(8.0 / ONE_MIN));
	return 0;
}

static int
record_highscore()
{
	int i;
	int j;
	for(i = 0; i < RANKING_MAX; i++) {
		if(hi_score[i * RANKING_RECORD + RANKING_SCORE] < score) {
			for(j = RANKING_MAX - 1; j > i; j--) {
				hi_score[j * RANKING_RECORD + RANKING_SCORE] = hi_score[(j - 1) * RANKING_RECORD + RANKING_SCORE];
				hi_score[j * RANKING_RECORD + RANKING_BREAK] = hi_score[(j - 1) * RANKING_RECORD + RANKING_BREAK];
				hi_score[j * RANKING_RECORD + RANKING_DESTR] = hi_score[(j - 1) * RANKING_RECORD + RANKING_DESTR];
			}
			hi_score[i * RANKING_RECORD + RANKING_SCORE] = score;
			hi_score[i * RANKING_RECORD + RANKING_BREAK] = brk_ship;
			hi_score[i * RANKING_RECORD + RANKING_DESTR] = enemy_dst;
			break; /*܂*/
		}
	}
	return i;
}

static void
TSKgctrlDrawStart(TSK* tsk)
{
	const char* str;
	int x;
	int y;
	int c;

	if(tsk->wait & 0x10) {
		str = "GAME START!";
		x = (DISP_X - strlen(str) * 4) / 2;
		y = (DISP_Y - 6) / 2;
		c = 0;
		render_printf(&render, x, y, 0x82, c, str);
	}
}

