#include "app.h"

/****************************************************************************
 *	
 ****************************************************************************/

#define RANKING_TIME	(ONE_SEC * 30)
#define RANKING_SKIP	(ONE_SEC * 27)

static const char* const ranking_rank[RANKING_MAX] = {
	" 1ST",
	" 2ND",
	" 3RD",
	" 4TH",
	" 5TH",
	" 6TH",
	" 7TH",
	" 8TH",
	" 9TH",
	"10TH",
};

static float pos_x[RANKING_MAX + 2/*LvVƃJwb_̕*/];
static float wait[RANKING_MAX + 2/*LvVƃJwb_̕*/];
static int rank_bar;

static void TSKrankingInit(TSK* tsk);
static void TSKrankingExec(TSK* tsk);
static void TSKrankingDraw(TSK* tsk);

void
TSKranking(TSK* tsk)
{
	switch(tsk->step) {
	case 0:
		TSKrankingInit(tsk);
		rank_bar = 0;
		tsk->fp_draw = TSKrankingDraw;
		tsk->wait = RANKING_TIME;
		tsk->step++;
		break;

	case 1:
		TSKrankingExec(tsk);
		if(tsk->wait) tsk->wait--;
		if(!tsk->wait ||
		  ((tsk->wait < RANKING_SKIP) && (joy & TRG_AB))) {
			ranking_exec = 0;
			tsk->step = -1;
		}
		break;

	default:
		clrTSK(tsk);
		break;
	}
}

static void
TSKrankingInit(TSK* tsk)
{
	static int type;
	int i;

	for(i = 0; i < ARRAY_SIZE(pos_x); i++) {
		switch(type) {
		case 0:
			pos_x[i] = DISP_X;
			wait[i] = i * 2;
			break;
		case 1:
			pos_x[i] = -DISP_X;
			wait[i] = i * 2;
			break;
		default:
			pos_x[i] = (i & 1) ? DISP_X : -DISP_X;
			wait[i] = 0;
			break;
		}
	}

	if(++type >= 3) type -= 3;
}

static void
TSKrankingExec(TSK* tsk)
{
	int i;

	for(i = 0; i < ARRAY_SIZE(pos_x); i++) {
		if(wait[i]) {
			wait[i]--;
		} else {
			pos_x[i] += (0.0f - pos_x[i]) / 15;
		}
	}

	if((ranking_exec > 0) && (tsk->wait < RANKING_SKIP)) {
		rank_bar = 1;
		if(++tsk->cnt >= 30) {
			tsk->cnt -= 60; /* 0,1,2,...,29,-30,-29,...,-2,-1,0 */
		}
	}
}

static void
TSKrankingDraw(TSK* tsk)
{
	const char* str;
	int i;
	int x;
	int y;
	int c;

	y = 6;

	str = " - HIGH SCORE RANKING - ";
	x = (DISP_X - strlen(str) * 4) / 2;
	x += (int)(pos_x[0] + 0.5);
	c = 0;
	render_printf(&render, x, y, 0x82, c, str);
	y += 8;

	str = "RANK BALLS BREAK DESTROY";
	x = (DISP_X - strlen(str) * 4) / 2;
	x += (int)(pos_x[1] + 0.5);
	c = 0;
	render_printf(&render, x, y, 0x82, c, str);
	y += 8;

	for(i = 0; i < RANKING_MAX; i++) {
		if(rank_bar && (ranking_exec == i + 1)) {
			c = _getColor(0.75,0.75,0.75,abs(tsk->cnt)/30.0f);
			render_rectangle_fill(&render, 0, y - 1, DISP_X, 7, c);
		}
		sprintf(str_buf, "%s   %03d   %3d     %3d",
			ranking_rank[i],
			hi_score[i * RANKING_RECORD + RANKING_SCORE],
			hi_score[i * RANKING_RECORD + RANKING_BREAK],
			hi_score[i * RANKING_RECORD + RANKING_DESTR]);
		x = (DISP_X - strlen(str_buf) * 4) / 2;
		x += (int)(pos_x[i + 2] + 0.5);
		c = 0;
		render_printf(&render, x, y, 0x82, c, str_buf);
		y += 6;
	}
}
