#include "app.h"

/****************************************************************************
 *	
 ****************************************************************************/

typedef struct _SND {
	const char* fname;
	int ch;
	int loop;
	const void* data;
} SND;

static SND snd_tbl[SND_COUNT] = {
	{ "bgm00.ppd", 3, -1 },
	{ "bgm01.ppd", 3, -1 },
	{ "bgm02.ppd", 3,  1 },
	//
	{ "se01.ppd",  0,  1 },
	{ "se02.ppd",  1,  1 },
	{ "se03.ppd",  1,  1 },
	{ "se04.ppd",  1,  1 },
	{ "se05.ppd",  0,  1 },
	{ "se06.ppd",  0,  1 },
	{ "se10.ppd",  1,  1 },
	{ "se11.ppd",  2,  1 },
	{ "se12.ppd",  2,  1 },
	{ "se13.ppd",  2,  1 },
};

void
sndINIT()
{
	const void* fpk = resource_address(APP_FNAME);
	int i;

	for(i = 0; i < SND_COUNT; i++) {
		snd_tbl[i].data = fpk_address(fpk, snd_tbl[i].fname, NULL);
	}
}

void
playSND(int no)
{
	SND* snd = &snd_tbl[no];
	sound_play(snd->ch, snd->data, snd->loop);
}

void
stopSND(int no)
{
	SND* snd = &snd_tbl[no];
	sound_stop(snd->ch);
}
