#include "app.h"

/****************************************************************************
 *	
 ****************************************************************************/

static void TSKsysinfoDraw(TSK* tsk);

void
TSKsysinfo(TSK* tsk)
{
	switch(tsk->step) {
	case 0:
		tsk->fp_draw = TSKsysinfoDraw;
		tsk->step++;
		break;

	case 1:
		/** no job **/
		break;

	default:
		clrTSK(tsk);
		break;
	}
}

static void
TSKsysinfoDraw(TSK* tsk)
{
	const char* str;
	int x;
	int y;
	int c;
	int tsec;
	int tmsec;

	if(g_step != GSTEP_RESULT) {
		x = 1;
		y = 1;
		c = 0;

		sprintf(str_buf, (score < 2) ? "BALL   :%d"
		                             : "BALLS  :%d", score);
		render_printf(&render, x, y, 0x82, c, str_buf);
		y += 6;

		sprintf(str_buf, (enemy_dst < 2) ? "ENEMY  :%d"
		                                 : "ENEMIES:%d", enemy_dst);
		render_printf(&render, x, y, 0x82, c, str_buf);

		tsec  = (play_time / ONE_SEC)       % ONE_SEC;
		tmsec = (play_time % ONE_SEC) * 100 / ONE_SEC;
		sprintf(str_buf, "REMAIN TIME:%02d:%02d", tsec, tmsec);
		x = DISP_X - strlen(str_buf) * 4;
		y = 1;
		render_printf(&render, x, y, 0x82, c, str_buf);
	} else {
		x = 1;
		y = 1;
		c = 0;

		str = "- RESULT -";
		render_printf(&render, x, y, 0x82, c, str);
		y += 8;

		sprintf(str_buf, (score < 2) ? "BALL       :%d"
		                             : "BALLS      :%d", score);
		render_printf(&render, x, y, 0x82, c, str_buf);
		y += 6;

		sprintf(str_buf, "BREAK SHIP :%d", brk_ship);
		render_printf(&render, x, y, 0x82, c, str_buf);
		y += 6;

		sprintf(str_buf, "DEST ENEMY :%d", enemy_dst);
		render_printf(&render, x, y, 0x82, c, str_buf);
		y += 8;

		str = "- PRESS SHOT BUTTON TO QUIT -";
		render_printf(&render, x, y, 0x82, c, str);
	}
}

