#include "app.h"

/****************************************************************************
 *	
 ****************************************************************************/

static POOL TskPool = { sizeof(TSK) };

void
initTSK()
{
	int i;

	for(i = 0; i < GROUP_MAX; i++) {
		InitializeListHead(&TskIndex[i]);
	}
}

TSK*
setTSK(int group, void (*fp)(TSK* tsk))
{
	TSK* tsk;

	tsk = pool_alloc(&TskPool);
	InsertTailList(&TskIndex[group], (LIST_ENTRY*)tsk);

	tsk->fp = fp;

	return tsk;
}

void
clrTSK(TSK* tsk)
{
	bulletDel(tsk);

	RemoveEntryList((LIST_ENTRY*)tsk);
	pool_free(tsk);
}

void
clrTSKgroup(int group)
{
	TSK* tsk;

	while(!IsListEmpty(&TskIndex[group])) {
		tsk = (TSK*)RemoveHeadList(&TskIndex[group]);
		clrTSK(tsk);
	}
}

void
execTSK()
{
	int i;
	LIST_ENTRY* head;
	LIST_ENTRY* link;
	TSK* tsk;

	for(i = 0; i < GROUP_MAX; i++) {
		head = &TskIndex[i];
		link = head->Flink;
		while(head != link) {
			tsk = (TSK*)link;
			link = link->Flink;
			if(tsk->fp) {
				tsk->fp(tsk);
			}
		}
	}
}

void
drawTSK()
{
	int i;
	LIST_ENTRY* head;
	LIST_ENTRY* link;
	TSK* tsk;

	for(i = 0; i < GROUP_MAX; i++) {
		head = &TskIndex[i];
		link = head->Flink;
		while(head != link) {
			tsk = (TSK*)link;
			link = link->Flink;
			if(tsk->fp_draw) {
				tsk->fp_draw(tsk);
			}
		}
	}
}

