#include "app.h"

/****************************************************************************
 *	
 ****************************************************************************/

#define TITLE_SX	96			/* ^CgS摜TCY */
#define TITLE_SY	8

#define TITLE_WAIT	(ONE_SEC * 30)		/* ^Cg^CAEgLOڍs */

static int title_mode;
static int menu_flag;				/* 0 = j[I, 1 = Im, 2 = LZ */
static int menu_sel;				/* 0 = GAME START, 1 = RANKING, 2 = EXIT */

static void TSKtitleDraw(TSK* tsk);
static void TSKmenu(TSK* tsk);
static void TSKmenuDraw(TSK* tsk);

void
TSKtitle(TSK* tsk)
{
	switch(tsk->step) {
	case 0:
		tsk->py = (DISP_Y / 2) - (TITLE_SY / 2) - 4 - 6;	/* ^Cg\W */
		tsk->step++;
		break;

	case 1:
		tsk->fp_draw = TSKtitleDraw;
		tsk->ty = (DISP_Y / 2) - (TITLE_SY / 2) - 4 - 6;	/* ^Cg\WڕW */
		tsk->cnt = 0;
		tsk->wait = TITLE_WAIT;
		tsk->alpha = 0.0f;					/* "HELLO WORLD PROJECT 2006"x */
		tsk->alpha_add = 1.0f / 30.0f;
		title_mode = 0;
		tsk->step++;
		/*FALLTHRU*/

	case 2:
		tsk->cnt++;
		tsk->alpha += tsk->alpha_add;				/* "HELLO WORLD PROJECT 2006"xω */
		if(tsk->alpha > 1.0f) tsk->alpha = 1.0f;
		tsk->py += (tsk->ty - tsk->py) / 10.0f;			/* ^Cg\WǏ] */
		if(--tsk->wait <= 0) {
			g_step = GSTEP_RANKING;
			tsk->step = -1;
			break; /*܂*/
		}
		if(joy & TRG_A) {
			playSND(SND_SECOLLECT);
			title_mode = 1;
			menu_flag = 0;
			menu_sel = 0;
			tsk->ty = 1;					/* ^Cg\WڕW */
			tsk->wait = 60;
			tsk->step++;
		}
		break;

	case 3:
		tsk->cnt++;
		tsk->alpha -= tsk->alpha_add;				/* "HELLO WORLD PROJECT 2006"xω */
		if(tsk->alpha < 0.0f) tsk->alpha = 0.0f;
		tsk->py += (tsk->ty - tsk->py) / 10.0f;			/* ^Cg\WǏ] */
		if(tsk->wait) tsk->wait--;
		if(tsk->wait == 30) setTSK(GROUP_INFO, TSKmenu);	/* j[^XNJn */
		if(tsk->wait) break; /*܂*/
		title_mode = 2;
		tsk->step++;
		break;

	case 4:
		tsk->py += (tsk->ty - tsk->py) / 15.0f;			/* ^Cg\WǏ] */
		switch(menu_flag) {
		case 1:							/* j[Im */
			switch(menu_sel) {
			case 0:						/* GAME START */
				g_step = GSTEP_GAME;
				tsk->step = -1;
				break;
			case 1:						/* RANKING */
				g_step = GSTEP_RANKING;
				playSND(SND_SECOLLECT);
				tsk->step = -1;
				break;
			default:					/* EXIT */
				exit(0);
			}
			break;
		case -1:						/* j[ILZ */
			playSND(SND_SECANCEL);
			tsk->step = 1;
			break;
		}
		break;

	default:
		clrTSK(tsk);
		break;
	}
}

static void
TSKtitleDraw(TSK* tsk)
{
	const char* str;
	int x;
	int y;
	int c;

	y = (int)(tsk->py + 0.5);

	str = "GAME-HELL 2000 SPORTS FESTIVAL";
	x = DISP_X - strlen(str) * 4;
	c = _getColor(0.75f,0.75f,0.75f,1.0f);
	render_printf(&render, x, y, 0x82, c, str);
	y += 6;

	render_line(&render, DISP_X * 0 / 3, y, x + DISP_X * 1 / 3, y, 0);
	render_line(&render, DISP_X * 1 / 3, y, x + DISP_X * 2 / 3, y, 1);
	render_line(&render, DISP_X * 2 / 3, y, x + DISP_X * 3 / 3, y, 2);
	y += 4;

	x = (DISP_X - TITLE_SX) / 2;
	sprite_draw(x, y, SPR_TTL, DRW_NOMAL);
	y += TITLE_SY + (4 - 1);

	render_line(&render, DISP_X * 0 / 3, y, x + DISP_X * 1 / 3, y, 2);
	render_line(&render, DISP_X * 1 / 3, y, x + DISP_X * 2 / 3, y, 1);
	render_line(&render, DISP_X * 2 / 3, y, x + DISP_X * 3 / 3, y, 0);
	y += 1;

	drawNoise(y - (4 + TITLE_SY + 4), 4 + TITLE_SY + 4);
	y += 1;

	str = "2006 AUTUMN VERSION";
	x = DISP_X - strlen(str) * 4;
	c = _getColor(0.75f,0.75f,0.75f,1.0f);
	render_printf(&render, x, y, 0x82, c, str);

	str = "HELLO WORLD PROJECT 2006";
	x = DISP_X - strlen(str) * 4;
	y = DISP_Y - 6;
	c = _getColor(0.75f,0.75f,0.75f,tsk->alpha);
	render_printf(&render, x, y, 0x82, c, str);

	if(((title_mode == 0) &&                     (tsk->cnt & 0x20)) ||
	   ((title_mode == 1) && (tsk->wait > 30) && (tsk->cnt & 0x04))) {
		str = " PRESS SHOT BUTTON";
		x = (DISP_X - strlen(str) * 4) / 2;
		y = 67/**/;
		c = _getColor(0.75f,0.75f,0.75f,1.0f);
		render_printf(&render, x, y, 0x82, c, str);
	}
}

static void
TSKmenu(TSK* tsk)
{
	switch(tsk->step) {
	case 0:
		tsk->fp_draw = TSKmenuDraw;
		tsk->vx = (DISP_X - strlen("GAME START") * 4) / 2;	/* j[\W */
		tsk->vy = DISP_Y / 2 + 6/**/;
		tsk->py = tsk->vy + 6 * menu_sel;			/* J[\\W */
		tsk->ty = tsk->vy + 6 * menu_sel;			/* J[\ڕWW */
		tsk->alpha = 0.0f;
		tsk->alpha_add = 1.0f / 30.0f;
		tsk->wait = 30;
		tsk->step++;
		/*FALLTHRU*/

	case 1:
		tsk->alpha += tsk->alpha_add;
		tsk->wait--;
		if(tsk->wait) break; /*܂*/
		tsk->step++;
		/*FALLTHRU*/

	case 2:
		tsk->py += (tsk->ty - tsk->py) / 5.0f;			/* J[\Ǐ] */
		if(joy & TRG_DN) { if(++menu_sel > 2) menu_sel = 0; playSND(SND_SESELECT); }
		if(joy & TRG_UP) { if(--menu_sel < 0) menu_sel = 2; playSND(SND_SESELECT); }
		tsk->ty = tsk->vy + 6 * menu_sel;
		if(joy & TRG_A) { menu_flag =  1; tsk->step = -1; }	/* j[Im */
		if(joy & TRG_B) { menu_flag = -1; tsk->step = -1; }	/* j[ILZ */
		break;

	default:
		clrTSK(tsk);
		break;
	}
}

static void
TSKmenuDraw(TSK* tsk)
{
	int x;
	int y;
	int w;
	int h;
	int c;

	x = 43;
	y = (int)(tsk->py + 0.5) - 1;
	w = 41;
	h = 7;
	c = _getColor(0.35f,0.35f,0.15f,tsk->alpha);
	render_rectangle_fill(&render, x, y, w, h, c);

	x = tsk->vx;
	y = tsk->vy;
	c = _getColor(1.0f,1.0f,1.0f,tsk->alpha);
	render_printf(&render, x, y, 0x82, c, "GAME START");
	y += 6;
	render_printf(&render, x, y, 0x82, c, "RANKING");
	y += 6;
	render_printf(&render, x, y, 0x82, c, "EXIT");
}

